/* rygel-regression.c generated by valac 0.44.9, the Vala compiler
 * generated from rygel-regression.vala, do not modify */

/*
 * Copyright (C) 2012 Jens Georg <mail@jensge.org>
 *
 * Author: Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <rygel-server.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#define RYGEL_TYPE_REGRESSION (rygel_regression_get_type ())
#define RYGEL_REGRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_REGRESSION, RygelRegression))
#define RYGEL_REGRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_REGRESSION, RygelRegressionClass))
#define RYGEL_IS_REGRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_REGRESSION))
#define RYGEL_IS_REGRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_REGRESSION))
#define RYGEL_REGRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_REGRESSION, RygelRegressionClass))

typedef struct _RygelRegression RygelRegression;
typedef struct _RygelRegressionClass RygelRegressionClass;
typedef struct _RygelRegressionPrivate RygelRegressionPrivate;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _rygel_regression_unref0(var) ((var == NULL) ? NULL : (var = (rygel_regression_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _RygelRegressionTest661482Data RygelRegressionTest661482Data;
typedef struct _RygelParamSpecRegression RygelParamSpecRegression;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _RygelRegression {
	GTypeInstance parent_instance;
	volatile int ref_count;
	RygelRegressionPrivate * priv;
};

struct _RygelRegressionClass {
	GTypeClass parent_class;
	void (*finalize) (RygelRegression *self);
};

struct _RygelRegressionPrivate {
	GMainLoop* loop;
};

struct _RygelRegressionTest661482Data {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelRegression* self;
	RygelSimpleContainer* container;
	RygelSimpleContainer* _tmp0_;
	RygelImageItem* item_1;
	RygelSimpleContainer* _tmp1_;
	RygelImageItem* _tmp2_;
	RygelImageItem* item_2;
	RygelSimpleContainer* _tmp3_;
	RygelImageItem* _tmp4_;
	RygelImageItem* item_3;
	RygelSimpleContainer* _tmp5_;
	RygelImageItem* _tmp6_;
	RygelSimpleContainer* _tmp7_;
	RygelImageItem* _tmp8_;
	RygelSimpleContainer* _tmp9_;
	RygelImageItem* _tmp10_;
	RygelSimpleContainer* _tmp11_;
	RygelImageItem* _tmp12_;
	RygelMediaObjects* list;
	RygelSimpleContainer* _tmp13_;
	RygelMediaObjects* _tmp14_;
	gint i;
	gboolean _tmp15_;
	RygelMediaObjects* children;
	RygelSimpleContainer* _tmp16_;
	RygelMediaObjects* _tmp17_;
	RygelMediaObjects* _tmp18_;
	gpointer _tmp19_;
	RygelMediaObject* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	RygelMediaObjects* _tmp23_;
	gpointer _tmp24_;
	RygelMediaObject* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	GError* _error_;
	GMainLoop* _tmp28_;
	GError* _inner_error0_;
};

struct _RygelParamSpecRegression {
	GParamSpec parent_instance;
};

static gint RygelRegression_private_offset;
static gpointer rygel_regression_parent_class = NULL;

gpointer rygel_regression_ref (gpointer instance);
void rygel_regression_unref (gpointer instance);
GParamSpec* rygel_param_spec_regression (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void rygel_value_set_regression (GValue* value,
                                 gpointer v_object);
void rygel_value_take_regression (GValue* value,
                                  gpointer v_object);
gpointer rygel_value_get_regression (const GValue* value);
GType rygel_regression_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelRegression, rygel_regression_unref)
gint rygel_regression_main (gchar** args,
                            gint args_length1);
RygelRegression* rygel_regression_new (void);
RygelRegression* rygel_regression_construct (GType object_type);
void rygel_regression_run (RygelRegression* self);
void rygel_regression_test_661482 (RygelRegression* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
void rygel_regression_test_661482_finish (RygelRegression* self,
                                          GAsyncResult* _res_);
static void rygel_regression_test_661482_data_free (gpointer _data);
static gboolean rygel_regression_test_661482_co (RygelRegressionTest661482Data* _data_);
static void rygel_regression_test_661482_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void rygel_regression_finalize (RygelRegression * obj);

static inline gpointer
rygel_regression_get_instance_private (RygelRegression* self)
{
	return G_STRUCT_MEMBER_P (self, RygelRegression_private_offset);
}

gint
rygel_regression_main (gchar** args,
                       gint args_length1)
{
	RygelRegression* test = NULL;
	RygelRegression* _tmp0_;
	gint result = 0;
	_tmp0_ = rygel_regression_new ();
	test = _tmp0_;
	rygel_regression_run (test);
	result = 0;
	_rygel_regression_unref0 (test);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return rygel_regression_main (argv, argc);
}

void
rygel_regression_run (RygelRegression* self)
{
	GMainLoop* _tmp0_;
	GMainLoop* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_main_loop_new (NULL, FALSE);
	_g_main_loop_unref0 (self->priv->loop);
	self->priv->loop = _tmp0_;
	rygel_regression_test_661482 (self, NULL, NULL);
	_tmp1_ = self->priv->loop;
	g_main_loop_run (_tmp1_);
}

static void
rygel_regression_test_661482_data_free (gpointer _data)
{
	RygelRegressionTest661482Data* _data_;
	_data_ = _data;
	_rygel_regression_unref0 (_data_->self);
	g_slice_free (RygelRegressionTest661482Data, _data_);
}

static gpointer
_rygel_regression_ref0 (gpointer self)
{
	return self ? rygel_regression_ref (self) : NULL;
}

void
rygel_regression_test_661482 (RygelRegression* self,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	RygelRegressionTest661482Data* _data_;
	RygelRegression* _tmp0_;
	_data_ = g_slice_new0 (RygelRegressionTest661482Data);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, rygel_regression_test_661482_data_free);
	_tmp0_ = _rygel_regression_ref0 (self);
	_data_->self = _tmp0_;
	rygel_regression_test_661482_co (_data_);
}

void
rygel_regression_test_661482_finish (RygelRegression* self,
                                     GAsyncResult* _res_)
{
	RygelRegressionTest661482Data* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
rygel_regression_test_661482_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	RygelRegressionTest661482Data* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	rygel_regression_test_661482_co (_data_);
}

static gboolean
rygel_regression_test_661482_co (RygelRegressionTest661482Data* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = rygel_simple_container_new ("0", NULL, "0");
	_data_->container = _data_->_tmp0_;
	_data_->_tmp1_ = _data_->container;
	_data_->_tmp2_ = rygel_image_item_new ("Z", (RygelMediaContainer*) _data_->_tmp1_, "Z", RYGEL_IMAGE_ITEM_UPNP_CLASS);
	_data_->item_1 = _data_->_tmp2_;
	_data_->_tmp3_ = _data_->container;
	_data_->_tmp4_ = rygel_image_item_new ("M", (RygelMediaContainer*) _data_->_tmp3_, "M", RYGEL_IMAGE_ITEM_UPNP_CLASS);
	_data_->item_2 = _data_->_tmp4_;
	_data_->_tmp5_ = _data_->container;
	_data_->_tmp6_ = rygel_image_item_new ("A", (RygelMediaContainer*) _data_->_tmp5_, "A", RYGEL_IMAGE_ITEM_UPNP_CLASS);
	_data_->item_3 = _data_->_tmp6_;
	_data_->_tmp7_ = _data_->container;
	_data_->_tmp8_ = _data_->item_1;
	rygel_simple_container_add_child_item (_data_->_tmp7_, (RygelMediaItem*) _data_->_tmp8_);
	_data_->_tmp9_ = _data_->container;
	_data_->_tmp10_ = _data_->item_2;
	rygel_simple_container_add_child_item (_data_->_tmp9_, (RygelMediaItem*) _data_->_tmp10_);
	_data_->_tmp11_ = _data_->container;
	_data_->_tmp12_ = _data_->item_3;
	rygel_simple_container_add_child_item (_data_->_tmp11_, (RygelMediaItem*) _data_->_tmp12_);
	{
		_data_->_tmp13_ = _data_->container;
		_data_->_state_ = 1;
		rygel_media_container_get_children ((RygelMediaContainer*) _data_->_tmp13_, (guint) 0, (guint) 3, "+dc:title", NULL, rygel_regression_test_661482_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp14_ = rygel_media_container_get_children_finish ((RygelMediaContainer*) _data_->_tmp13_, _data_->_res_, &_data_->_inner_error0_);
		_data_->list = _data_->_tmp14_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		{
			_data_->i = 0;
			{
				_data_->_tmp15_ = TRUE;
				while (TRUE) {
					if (!_data_->_tmp15_) {
						_data_->i = _data_->i + 1;
					}
					_data_->_tmp15_ = FALSE;
					if (!(_data_->i < 3)) {
						break;
					}
					_data_->_tmp16_ = _data_->container;
					_data_->_state_ = 2;
					rygel_media_container_get_children ((RygelMediaContainer*) _data_->_tmp16_, (guint) _data_->i, (guint) 1, "+dc:title", NULL, rygel_regression_test_661482_ready, _data_);
					return FALSE;
					_state_2:
					_data_->_tmp17_ = rygel_media_container_get_children_finish ((RygelMediaContainer*) _data_->_tmp16_, _data_->_res_, &_data_->_inner_error0_);
					_data_->children = _data_->_tmp17_;
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
						_g_object_unref0 (_data_->list);
						goto __catch0_g_error;
					}
					_data_->_tmp18_ = _data_->children;
					_data_->_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp18_, 0);
					_data_->_tmp20_ = (RygelMediaObject*) _data_->_tmp19_;
					_data_->_tmp21_ = rygel_media_object_get_title (_data_->_tmp20_);
					_data_->_tmp22_ = _data_->_tmp21_;
					_data_->_tmp23_ = _data_->list;
					_data_->_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp23_, _data_->i);
					_data_->_tmp25_ = (RygelMediaObject*) _data_->_tmp24_;
					_data_->_tmp26_ = rygel_media_object_get_title (_data_->_tmp25_);
					_data_->_tmp27_ = _data_->_tmp26_;
					_vala_assert (g_strcmp0 (_data_->_tmp22_, _data_->_tmp27_) == 0, "children[0].title == list[i].title");
					_g_object_unref0 (_data_->_tmp25_);
					_g_object_unref0 (_data_->_tmp20_);
					_g_object_unref0 (_data_->children);
				}
			}
		}
		_g_object_unref0 (_data_->list);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->_error_ = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (_data_->_error_);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->item_3);
		_g_object_unref0 (_data_->item_2);
		_g_object_unref0 (_data_->item_1);
		_g_object_unref0 (_data_->container);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp28_ = _data_->self->priv->loop;
	g_main_loop_quit (_data_->_tmp28_);
	_g_object_unref0 (_data_->item_3);
	_g_object_unref0 (_data_->item_2);
	_g_object_unref0 (_data_->item_1);
	_g_object_unref0 (_data_->container);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

RygelRegression*
rygel_regression_construct (GType object_type)
{
	RygelRegression* self = NULL;
	self = (RygelRegression*) g_type_create_instance (object_type);
	return self;
}

RygelRegression*
rygel_regression_new (void)
{
	return rygel_regression_construct (RYGEL_TYPE_REGRESSION);
}

static void
rygel_value_regression_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
rygel_value_regression_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		rygel_regression_unref (value->data[0].v_pointer);
	}
}

static void
rygel_value_regression_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = rygel_regression_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
rygel_value_regression_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
rygel_value_regression_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		RygelRegression * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = rygel_regression_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
rygel_value_regression_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	RygelRegression ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = rygel_regression_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
rygel_param_spec_regression (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	RygelParamSpecRegression* spec;
	g_return_val_if_fail (g_type_is_a (object_type, RYGEL_TYPE_REGRESSION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
rygel_value_get_regression (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, RYGEL_TYPE_REGRESSION), NULL);
	return value->data[0].v_pointer;
}

void
rygel_value_set_regression (GValue* value,
                            gpointer v_object)
{
	RygelRegression * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, RYGEL_TYPE_REGRESSION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, RYGEL_TYPE_REGRESSION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		rygel_regression_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		rygel_regression_unref (old);
	}
}

void
rygel_value_take_regression (GValue* value,
                             gpointer v_object)
{
	RygelRegression * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, RYGEL_TYPE_REGRESSION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, RYGEL_TYPE_REGRESSION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		rygel_regression_unref (old);
	}
}

static void
rygel_regression_class_init (RygelRegressionClass * klass,
                             gpointer klass_data)
{
	rygel_regression_parent_class = g_type_class_peek_parent (klass);
	((RygelRegressionClass *) klass)->finalize = rygel_regression_finalize;
	g_type_class_adjust_private_offset (klass, &RygelRegression_private_offset);
}

static void
rygel_regression_instance_init (RygelRegression * self,
                                gpointer klass)
{
	self->priv = rygel_regression_get_instance_private (self);
	self->ref_count = 1;
}

static void
rygel_regression_finalize (RygelRegression * obj)
{
	RygelRegression * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_REGRESSION, RygelRegression);
	g_signal_handlers_destroy (self);
	_g_main_loop_unref0 (self->priv->loop);
}

GType
rygel_regression_get_type (void)
{
	static volatile gsize rygel_regression_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_regression_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { rygel_value_regression_init, rygel_value_regression_free_value, rygel_value_regression_copy_value, rygel_value_regression_peek_pointer, "p", rygel_value_regression_collect_value, "p", rygel_value_regression_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (RygelRegressionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_regression_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelRegression), 0, (GInstanceInitFunc) rygel_regression_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType rygel_regression_type_id;
		rygel_regression_type_id = g_type_register_fundamental (g_type_fundamental_next (), "RygelRegression", &g_define_type_info, &g_define_type_fundamental_info, 0);
		RygelRegression_private_offset = g_type_add_instance_private (rygel_regression_type_id, sizeof (RygelRegressionPrivate));
		g_once_init_leave (&rygel_regression_type_id__volatile, rygel_regression_type_id);
	}
	return rygel_regression_type_id__volatile;
}

gpointer
rygel_regression_ref (gpointer instance)
{
	RygelRegression * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
rygel_regression_unref (gpointer instance)
{
	RygelRegression * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		RYGEL_REGRESSION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

